Description

Things don't seem to work right if | have multiple copies of the same KAR file in a single local repository. | think this is related to only
one entry for an LSID being allowed in a repository.

If | make a file system copy of the KAR file, only one copy (the oldest?) will show up in Kepler, which could be reasonable if
potentially confusing and inconvenient. | presume this is because the KAR files have identical LSIDs.

However, if | open the KAR in Kepler and Save Archive to create a copy, that copy will show up in Kepler, will appear to be empty
(lacking XML and ROML entries), but can be opened. The original remains as before. | think this is because the KAR files have
different LSIDs, but the XML and ROML files have the same.

Maybe this is as intended, but it's certainly confusing because the KARs look empty and the folder/KAR listing does not accurately
reflect the file system structure.

Related issues:
Blocked by Kepler - Bug #4559: local repositories not showing up in component... Resolved 11/19/2009

History

#1 - 11/04/2009 09:19 AM - ben leinfelder

If i'm imagining this correctly, it would be the same as having any other "components" show up multiple times in the component tree (like when they
have multiple semantic types). Except for this case we're talking about the same XML workflow showing under multiple KAR parents. That seems
reasonable.

#2 - 11/06/2009 11:44 AM - ben leinfelder

now that i've seen this...it's very confusing indeed!
I think it's absolutely fine to have the "same" (LSID matches) KAREntries show for every KAR that contains them.

#3 - 12/02/2009 11:41 AM - Aaron Aaron

With the new Library changes, having two different KARS with the same LSIDs works fine now.

As for having multiple identical KARS in the local repositories (i.e. the KAR LSIDs are the same) this is a structural flaw of the database desing.
Because the primary key of the KARS_CACHED table is the KAR LSID there is no way to keep track of multiple copies of the same KAR at the
moment. During the cache synchronization any identical KARS are just skipped.

This could be fixed by making the primary key of the KARS_CACHED table an autoincremented integer instead of the KAR LSID. This would change
the KAR_CONTENTS table as well since it has a foreign key to the KAR LSID in the KARS_CACHED table. Some code changes would be needed
as well in order to properly handle identical KARS.

It certainly wouldn't be too terribly impossible to fix this but may take a couple days of time.

#4 - 12/02/2009 11:45 AM - Aaron Aaron

| should clarify the first statement in my previous comment.

Two different KARs (i.e. each KAR has a different KAR LSID) that contain the same contents (i.e. KAREntries that have the same LSID) works fine
now with the latest Library changes.

#5 - 12/05/2009 01:19 PM - Aaron Aaron

The primary key used for the KARS_CACHED table has been changed to be the full File path for the KAR. So you can now have multiple identical
KAR files in the component library after revision 22083
#6 - 03/27/2013 02:27 PM - Redmine Admin
Original Bugzilla ID was 4512
